"""
http://www.rosettacode.org/wiki/Pyramid_of_numbers
"""

from pycsp3 import *

n, k = data

# x[o,p] is the value of A(o,p)
x = VarArray(size=[n, n], dom=lambda i, j: range(k + 1) if j <= i else None)

satisfy(
    # imposing a non-null root
    x[0][0] != 0,

    # imposing different values
    AllDifferent(x),

    # computing triangle sums
    [x[i][j] == x[i + 1][j] + x[i + 1][j + 1] for i in range(n - 1) for j in range(i + 1)]
)

minimize(
    # minimizing the root value of the triangle
    x[0][0]
)
